#!/bin/sh
# bou.sh # Lit des pièces de musique au format ogg à l'aide
# ........ de mplayer et affiche leur info interne dans une
# ........ fenêtre de less.
#
# Dépendances : tree, awk, vorbiscomment, mplayer, less (le 
# ............. vrai, pas celui de busybox), et kill.
# Autres : le script pkbou.sh, ainsi que les liens pkbou 
# ........ et kbou (pour pouvoir interrompre avant la fin).
#
# Usage : pour passer manuellement à la pièce suivante, 
# ....... taper « q » dans la fenêtre. Sinon, c'est
# ....... automatique. 
# ....... Pour forcer la fermeture, voir les instructions
# ....... dans le script < pkbou.sh >.
# 
# Merci à Philippe (alias "augras" dans le forum Puppy) 
# ..... de ses tests du protype et de son appui. ......
#
# (c) Christian L'Écuyer, alias "musher0" (forum PuppyLinux), 
# ....... Gatineau (Qc), Canada, 30-31 mai 2016. GPL2. ......
#### set -xe
DiR="$@";cd "$DiR"
> bou;> liste

CoLoR="bd AntiqueWhite2 -bg AntiqueWhite4 -fg white"
YaF="margin 15 -$CoLoR -bw 10 -font LiberationSerif -fontsize 15 -timeout 5 -outline 0"

if [ "`pgrep mplayer`" ];then # Si mplayer joue déjà (une seule instance).
	[ "${LANG:0:2}" = "fr" ] && DEJA="MPlayer joue déjà." || DEJA="MPlayer is already playing."
	yaf-splash -$YaF -text "$DEJA" # 1ère vérif.

else # Obtenir le nom de fichier des pièces ogg.
	tree -fi . | awk -F"/" '$0 ~ /ogg/ { print $2 }' > liste
	if [ `wc -l < liste` -gt 0 ];then # 2e vérif.

	# Variable pour mplayer
		LvL="cplayer=0:demuxer=0:demux=0:decaudio=0:decvideo=0:subreader=0:lirc=0:cache=0:statusline=0"

	# Variables pour urxvt
		FNT="fn xft:Monaco:pixelsize=15:antialias=true:autohint=true" # Ou / Or LiberationMono
		ColR="bg Sienna4 -fg NavajoWhite1";TinT="tr -tint beige -sh 55"
		FadE="fade 70 -fadecolor "#94A495""
		PiX="pixmap /root/my-documents/My-images/partition/headphones-wallpaper-640x480.jpg"
		TitR="`echo $PWD | awk -F"/" '{ print $NF }'`";TitR=" ^ $TitR ^ "
	
	# Variable pour less
		case "${LANG:0:2}" in 
			fr)InvT="         ^    Ce que joue mplayer    ^         " ;;
			*) InvT="       ^    What mplayer is playing    ^       " ;; 
		esac	

		nPiCs="`ls -1 "$DiR"/*.jpg | wc -l`" # pochette
		if [ "$nPiCs" -gt "0" ];then 
			[ -x /usr/bin/qiv ] && VWR="qiv -d 10 -s -w 350" || VWR="defaultimageviewer --slideshow" 
			#..................... If / si qiv ...............# ..........If / si gpicvview ...........
			# ............ diaporama activé / with slideshow. # Less interesting / Moins intéressant.
			$VWR "$DiR"/*.jpg & 
		fi 
	# Action		
		cat liste | while read line;do # boucle
		# Jouer la pièce # -msgmodule # pour déboguer
			mplayer -msgcolor -msglevel $LvL -cache 8000 "$line" & 
		# Joue en boucle, en fond, sans fenêtre.

		# Préparer l'affichage
			echo -e "\n- $PWD -\n-- $line --\n." > bou # Where these ogg files are 
			vorbiscomment "$line" | grep -E -v "abcde|freac|CDTOC|CDDB|TOTAL" | sort | tr -s " " >> bou
		# ALBUM|album| # parfois nécessaire de laisser cette info.
			# ............................^ On élague un peu. ^
			echo -e "\n." >> bou

		# Afficher
			LarG="`wc -L < bou`";LarG="`expr $LarG + 1`";HauT="`wc -l < bou`";Haut="`expr $HauT + 4`" 
			GeoM="g "$LarG"x"$HauT"-150+150" # Fenêtre s'adapte à la hauteur et à la largeur du texte.
			urxvt -title "$TitR" -$FNT -$GeoM +sb -$ColR -$FadE -$PiX -e less -~ -P "$InvT" bou
			kill -s 9 `pgrep mplayer` # Si on tape 'q' dans less, on ferme mplayer, et
			# ......................... on passe à la pièce suivante à cause de la boucle.
		done
		rm -f bou;rm -f liste # Nettoyer la place. 
		killall -q $VWR
		
	else
		NapaS="Il n'y a pas de fichiers ogg dans ce répertoire."
		yaf-splash -$YaF -text "$NapaS"
	fi
fi  # set +xe
